# class Devise::Strategies::DatabaseAuthenticatable

Default strategy for signing in a user, based on his email and password in the database.

### Public Instance Methods

authenticate!() click to toggle source

    # File lib/devise/strategies/database_authenticatable.rb, line 7
    def authenticate!
      resource = valid_password? && mapping.to.find_for_database_authentication(authentication_hash)

      if validate(resource){ resource.valid_password?(password) }
        resource.after_database_authentication
        success!(resource)
      elsif !halted?
        fail(:invalid)
      end
    end